#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <math.h>
#include "BigIntegerLibrary.hh"
#include "omp.h"
using namespace std;

//# if defined(_OPENMP)
//printf("Compiled by an OpenMP-compliant implementation.\n");
//# endif

BigInteger x,y,f,R,i,A,B,p,ubount;
int nthreads, tid;
long n;
double t;
bool flag;

bool find_point_y();
void brutef_find_y();

int main(){

	std::string s;
printf("\nFind points on eliptic curves y^2 = x^3 + Ax + B (mod p) with Brute Force\n");
printf("\nDefine number of threads to be used:");
cin>>n;

/*
if (n>=omp_get_num_procs()){
	n=omp_get_num_procs();
}
*/

printf("\nInsert A:");
cin>>s;
A=stringToBigInteger(s);
s="";
printf("\nInsert B:");
cin>>s;
B=stringToBigInteger(s);
s="";
printf("\nInsert p:");
cin>>s;
p=stringToBigInteger(s);
s="";
printf("\nInsert a starting point x:");
cin>>s;
x=stringToBigInteger(s);
//cout<<"\n"<<4%2<<"\n";
t=omp_get_wtime();
brutef_find_y();
cout<<"Time of execution: "<<omp_get_wtime()-t<<"\n";
return 0;
}

void brutef_find_y(){
	
//In This version the two functions merged inside the parralel part of the algorithm		
// y^2 = x^3 + Ax + B (mod p)
	flag=false;
	x--; //We do this because there is a x++ in #pragma omp single

omp_lock_t lck;
omp_init_lock(&lck);
omp_set_num_threads(n);
#pragma omp parallel shared(p,R,A,B,flag,f, x) private(nthreads, tid,y,i,ubount) 
{
	while(flag==false){
	//#pragma ordered
/* Initialize private parammeters for each thread*/
	/* Obtain thread number */
	 tid = omp_get_thread_num();
    /*Obtain total number of threads*/  
     nthreads = omp_get_num_threads();
	 
	i=0;	
		#pragma omp single
		{
			x++;
			R=x * x * x;
			R=R + (A * x) + B;
			R=(R%p);
		}
	 
   if (i==0){
   if (tid==(nthreads-1)){
    ubount=p;
	i=p/nthreads;
	i=i*tid;
	i=i-1;
   }else{
	ubount=tid+1;
	ubount=ubount*(p/nthreads);
	ubount=ubount+1;
	i=p/nthreads;
	i=i*tid;
	i=i-1;
   }
   }
 
  //Check if threads work. Uncomment these lines to see if threads are created
  if (tid == 0) 
    {
    nthreads = omp_get_num_threads();
    printf("Number of threads = %d\n", nthreads);
    }
  printf("Hello World from thread = %d\n", tid);
 
	//#pragma omp while scedule(guided,1) 
	while((i<=ubount) && (flag==false)){
			
  		y=i*i;
		y=(y%p);
		if (y==R){
			omp_set_lock(&lck);
			//Alternatively instead of a lock a critical region can be used
			//#pragma opm critical
			//{
				f=i;
				flag=true;
			//}
			omp_unset_lock(&lck);
			
		}
		 //printf("Hello World from thread = %d   ", tid);
		 //cout<<i<<"\n";
		
		i++;
		
	}//End of while((i<=ubount) && (flag==false))
   
 
	}//End of while(flag==false)
}                      
omp_destroy_lock(&lck);
	
	if (flag==true){
	  if (f<=(p-f)){
		cout<<"\nThe point:(x="<<x<<",  y="<<f<<") belongs on the eliptic curve y^2 = x^3 + "<<A<<"*x + "<<B<<" mod("<<p<<")\n";
		cout<<"\nThe point:(x="<<x<<",  y="<<p-f<<") also belongs on the eliptic curve y^2 = x^3 + "<<A<<"*x + "<<B<<" mod("<<p<<") .\nThis is the symetric point.\n\n";
	  }else{
	  	cout<<"\nThe point:(x="<<x<<",  y="<<p-f<<") belongs on the eliptic curve y^2 = x^3 + "<<A<<"*x + "<<B<<" mod("<<p<<")\n";
		cout<<"\nThe point:(x="<<x<<",  y="<<f<<") also belongs on the eliptic curve y^2 = x^3 + "<<A<<"*x + "<<B<<" mod("<<p<<") .\nThis is the symetric point.\n\n";
	  }
	}	
	
}
