#include <iostream>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>


#include "omp.h"
#include "simple-generator.h"


  static void destroy_window( GtkWidget *widget,
                      gpointer  pointer )
 {
     gtk_main_quit ();
 }
 
 void move_button();
 void pi_calc();
 
    GtkWidget *window;
    GtkWidget *fixed;
 	GtkWidget *label;
 	GtkWidget *button;
 	GtkWidget *view;
	GtkTextBuffer *buffer;
    GtkWidget *scrolled_window;
    GtkWidget *entry1;
	GtkWidget *entry2;
	GtkWidget *entry3;
 	GtkTextIter startiter;
 	GtkTextIter stopiter;
    gint offset;
	 
	
  double x_value, y_value; 
  long hit,n_darts=1;
  char str[300];
  long n=omp_get_num_procs();
  int nthreads, tid, i, seed;
    
 int main(int argc, char *argv[])
 {
 	  
 	gtk_init (&argc, &argv);
 	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 	 gtk_window_set_title(GTK_WINDOW(window), "Montecarlo pi");
 	gtk_window_set_default_size (GTK_WINDOW (window), 330, 420);
 	g_signal_connect (G_OBJECT (window), "destroy",G_CALLBACK (destroy_window), NULL);
 	
 	
 	fixed=gtk_fixed_new();
 	gtk_container_add (GTK_CONTAINER (window), fixed);
 	gtk_widget_show(fixed);
 	
 		
	button = gtk_button_new_with_label ("Calculate pi");
      gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (move_button), fixed);
      gtk_fixed_put (GTK_FIXED (fixed), button, 20, 300);
      
	  
  view = gtk_text_view_new ();
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
  gtk_text_buffer_set_text (buffer, " ", -1);
  
    
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_set_border_width (GTK_CONTAINER (scrolled_window), 10);
  
  gtk_widget_set_usize(scrolled_window, 310, 290);
  
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
      gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_window), view);
      gtk_fixed_put (GTK_FIXED (fixed), scrolled_window, 10, 10);
      
    entry1= gtk_entry_new();
    gtk_entry_set_max_length(GTK_ENTRY(entry1), 30);
	gtk_entry_set_width_chars(GTK_ENTRY(entry1), 25);
    gtk_entry_set_text(GTK_ENTRY(entry1),"Enter number of threads here");
    gtk_fixed_put (GTK_FIXED (fixed), entry1, 20, 340); 
	
	entry2= gtk_entry_new();
    gtk_entry_set_max_length(GTK_ENTRY(entry2), 30);
	gtk_entry_set_width_chars(GTK_ENTRY(entry2), 25);
    gtk_entry_set_text(GTK_ENTRY(entry2),"Enter number of points here");
    gtk_fixed_put (GTK_FIXED (fixed), entry2, 20, 375); 
	
	entry3= gtk_entry_new();
    gtk_entry_set_max_length(GTK_ENTRY(entry3), 18);
	gtk_entry_set_width_chars(GTK_ENTRY(entry3), 18);
    gtk_entry_set_text(GTK_ENTRY(entry3),"Enter random seed");
    gtk_fixed_put (GTK_FIXED (fixed), entry3, 120, 300); 
    
 	gtk_widget_show_all (window);
 	gtk_main ();
 	return 0;
 }
 
 void move_button(){
pi_calc();

 }


 void pi_calc(){

	   seed=atoi(gtk_entry_get_text(GTK_ENTRY(entry3)));;
    
  gtk_text_buffer_set_text (buffer, " ", -1);

if (n>=omp_get_num_procs()){
	n=omp_get_num_procs();
}

	 n_darts=atol(gtk_entry_get_text(GTK_ENTRY(entry2)));
		
      gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, "\nCalculating pi using ", -1);
	  
      gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%ld",n_darts);
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, " number of \nrandom points and ", -1);
    
	 n=atol(gtk_entry_get_text(GTK_ENTRY(entry1)));
	       
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%ld",n);
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, " number of threads\n", -1);
	
    if (n_darts!=0)
      {
	//reset the hit variable
	hit=0;
omp_set_num_threads(n);

double t=omp_get_wtime();

#pragma omp parallel shared(n_darts) private(nthreads, tid,x_value,y_value) reduction(+:hit)
{
	
	/* Obtain thread number */
	 tid = omp_get_thread_num();
    /*Obtain total number of threads*/  
     nthreads = omp_get_num_threads();
unsigned int rand_work;
rand_work = seed + tid;
      
  if (tid == 0) 
    {
		#pragma omp critical
		{
    nthreads = omp_get_num_threads();
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, "\nNumber of threads = ", -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%d",nthreads);
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
   
		}
    }
	
	#pragma omp critical
		{
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, "\nHello World from thread = ", -1);
  
      gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%d",tid);
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
       }
 
	#pragma omp for schedule(static) nowait  		
	for(i=0;i<n_darts;i++)
	  {
	   
	    x_value = simple_random(&rand_work);
        y_value = simple_random(&rand_work);
	  
	    
	    if (((x_value*x_value)+(y_value*y_value))<=1){
	    	
	    	 hit++;
	    	 
	    }
	    
	  }
}
      gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, "\n\nThere were " , -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%ld",hit);
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
	  
	   gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, " hits in the circle \n" , -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, "\nThe estimated value of pi is: " , -1);
	  
	   gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%1.10f",((hit*4)/static_cast<double>(n_darts)));
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &stopiter, "\n\nTime passed: " , -1);
	  
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
	  sprintf(str,"%lg",(omp_get_wtime()-t));
	  gtk_text_buffer_insert  (buffer, &stopiter, str, -1);
	  

}
	  
 
 }
