#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <ctime> 
#include <cstdlib>
#include <math.h>
#include <string>

#include "simple-generator.h"
#include "omp.h"
using namespace std;

int main(){
	string s;
	double d,res;
	double x, y, r;
	unsigned long i,points,points_in;
	long n=omp_get_num_procs();
	int nthreads, tid, seed;
	seed=386;
		
	r=1;
		
	cout<<"Calculation of pi with Monte Carlo method:\n";
         
cout<<"\nDefine number of processors to be used:";
cin>>n;
cout<<"\nDefine the seed to be used for randomization:";
cin>>seed;
if (n>=omp_get_num_procs()){
	n=omp_get_num_procs();
}
        
    
	points_in=0;
	
	cout<<"\nGive number of points: ";
    cin>>points;
    if(points<=1){
    	points=100;
	}
		


double t=omp_get_wtime();
omp_set_num_threads(n);
#pragma omp parallel shared(points, r) private(nthreads, tid,i,x,y,d) reduction (+:points_in)
{	
/* Obtain thread number */
	 tid = omp_get_thread_num();
    /*Obtain total number of threads*/  
     nthreads = omp_get_num_threads();
 
unsigned int rand_work;
rand_work = seed + tid;
      
  if (tid == 0) 
    {
    nthreads = omp_get_num_threads();
    printf("\nNumber of threads = %d", nthreads);
    }
  printf("\nHello World from thread = %d", tid);

i=1;
#pragma omp for   
for(i=1; i<=points;i++){ 
    	
         x = simple_random(&rand_work);
         y = simple_random(&rand_work);
           
        d=sqrt((x*x)+(y*y));
        if(d<=r){
        	
        	points_in+=1;
        	
		}
		
        //cout << x/y << endl; 
    }
  printf("\nthread = %d    points_in=%lu", tid,points_in);   

}	

	res=4*((long double)(points_in)/(long double)(points));
		
std::cout.precision( 17 ) ;
//std::cout.setf( std::ios::fmtflags(), std::ios::floatfield ) ;
cout<<"\n\npoints_in= "<<points_in<<"   pi= "<< res<<"\n\n";
cout<<"Time passed: "<<omp_get_wtime()-t<<"\n\n";
   return 0;
}

