#include <iostream>
#include <iomanip>
#include "omp.h"
#include "simple-generator.h"
using namespace std;


int main(){
  double x_value, y_value; 
  long hit,n_darts=1;
  
  long n=omp_get_num_procs();
  int nthreads, tid, i, seed;
  seed=386;
    
  while(n_darts!=0){
    
    cout<<"\nThis program estimates Pi by the Monte Carlo method.\n";

cout<<"\nDefine number of processors to be used:";
cin>>n;
cout<<"\nDefine the seed to be used for randomization:";
cin>>seed;
if (n>=omp_get_num_procs()){
	n=omp_get_num_procs();
}
    cout<<"\nHow many random points do you want to use? (0 to quit) ";
    cin>>n_darts;
    
    if (n_darts!=0)
      {
	//reset the hit variable
	hit=0;
omp_set_num_threads(n);

double t=omp_get_wtime();
 
#pragma omp parallel shared(n_darts) private(nthreads, tid,x_value,y_value) reduction(+:hit)
{
	
	/* Obtain thread number */
	 tid = omp_get_thread_num();
    /*Obtain total number of threads*/  
     nthreads = omp_get_num_threads();
unsigned int rand_work;
rand_work = seed + tid;
      
  if (tid == 0) 
    {
    nthreads = omp_get_num_threads();
    printf("\nNumber of threads = %d", nthreads);
    }
  printf("\nHello World from thread = %d", tid);
	
	#pragma omp for schedule(static) nowait  		
	for(i=0;i<n_darts;i++)
	  {
	   
	    x_value = simple_random(&rand_work);
        y_value = simple_random(&rand_work);
	  
	    
	    if (((x_value*x_value)+(y_value*y_value))<=1){
	    	
	    	 hit++;
	    	 
	    }
	    
	  }
}

	
	cout<<"\n\nThere were "<<hit<<" hits in the circle \n";
	cout<<"\nThe estimated value of pi is: "
	    <<setiosflags(ios::fixed|ios::showpoint)
	    <<setprecision(17)
	    <<(hit*4)/static_cast<double>(n_darts)<<"\n";
	cout<<"\nTime passed: "<<omp_get_wtime()-t<<"\n\n";
	
      }
    
	}

  return 0;
}
