#include <iostream>
#include <ctime>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include "omp.h"
using namespace std;


int main(){
  double x_value, y_value; 
  long int hit,n_darts=1;
  
  long n=omp_get_num_procs();
  int nthreads, tid, i;
  //generating the seed value for the random numbers
   
  while(n_darts!=0){
    
    cout<<"\nThis program estimates Pi by the Monte Carlo method.\n";
   cout<<"\nDefine number of processors to be used:";
cin>>n;
if (n>=omp_get_num_procs()){
	n=omp_get_num_procs();
}
    cout<<"\nHow many darts do you want to throw? (0 to quit) ";
    cin>>n_darts;
    
    if (n_darts!=0)
      {
	//reset the hit variable
	hit=0;
omp_set_num_threads(n);
omp_lock_t lck;
omp_init_lock(&lck);
#pragma omp parallel shared(n_darts,hit) private(nthreads, tid,i,x_value,y_value) 
{
	
	/* Obtain thread number */
	 tid = omp_get_thread_num();
    /*Obtain total number of threads*/  
     nthreads = omp_get_num_threads();

 srand(time(0)+tid); 
      
  if (tid == 0) 
    {
    nthreads = omp_get_num_threads();
    printf("Number of threads = %d\n", nthreads);
    }
  printf("Hello World from thread = %d\n", tid);
	
	#pragma omp for   		
	for(i=0;i<n_darts;i++)
	  {
	   
	    x_value = static_cast<double>(rand())/RAND_MAX; 
	    y_value = static_cast<double>(rand())/RAND_MAX;
	  
	    
	    if (((x_value*x_value)+(y_value*y_value))<=1){
	    	 omp_set_lock(&lck);
	    	 hit++;
	    	 omp_unset_lock(&lck);
	    }
	    
	  }
}
omp_destroy_lock(&lck);
	
	cout<<"There were "<<hit<<" hits in the circle \n";
	cout<<"The estimated value of pi is: "
	    <<setiosflags(ios::fixed|ios::showpoint)
	    <<setprecision(15)
	    <<(hit*4)/static_cast<double>(n_darts)<<"\n";
	
      }
    
	}

  return 0;
}
