/*
 * Function for simple RNG to generate doubles.
 * Algorithm is LCG using constants from Wikipedia page.
 */
static unsigned int A = 1664525;
static unsigned int B = 1013904223;
static unsigned int SIMPLE_RANDMAX = 0xffffffff;

double simple_random(unsigned int * current) {
    unsigned int val = *current;
    val = ( (val * A) + B ) & SIMPLE_RANDMAX;
    *current = val;
    return ((double) val) / ((double) SIMPLE_RANDMAX);
}
