/* chatserver.c */

#include <stdlib.h>
#include <stdio.h>
#include <cnaiapi.h>

#define BUFFSIZE		256
#define INPUT_PROMPT		"Input   > "
#define RECEIVED_PROMPT		"Received> "

int recvln(connection, char *, int);
int readln(char *, int);

/*-----------------------------------------------------------------------
 *
 * Program: chatserver
 * Purpose: wait for a connection from a chatclient & allow users to chat
 * Usage:   chatserver <appnum>
 *
 *-----------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{
	connection	conn;
	int		len,opt;
	char		buff[BUFFSIZE];

	if (argc != 3) {
		(void) fprintf(stderr, "usage: %s <appnum> <function select 1=send 2=receive>\n", argv[0]);
		exit(1);
	}

	(void) printf("Chat Server Waiting For Connection.\n");

	/* wait for a connection from a chatclient */

	conn = await_contact((appnum) atoi(argv[1]));
	opt=atoi(argv[2]);// 1 for sending only 2 for receiving only
	if (conn < 0)
		exit(1);
	
	(void) printf("Chat Connection Established.\n");
	
	/* iterate, reading from the client and the local user */
	switch (opt){
	case 1:
		(void) printf("Send Server Sterted on Port %d.\n",atoi(argv[1]));
		(void) printf("Connection Established.\n");
		(void) printf(INPUT_PROMPT);
		(void) fflush(stdout);

	/* iterate, reading from local user and then from chatserver */

		while((len = readln(buff, BUFFSIZE)) > 0) {
			buff[len - 1] = '\n';
			(void) send(conn, buff, len, 0);
		
			(void) printf(INPUT_PROMPT);
			(void) fflush(stdout);
		}
		break;
	case 2:
		(void) printf("Receive Server Sterted on Port %d.\n",atoi(argv[1]));
		(void) printf("Connection Established.\n");
	while((len = recvln(conn, buff, BUFFSIZE)) > 0) {
		(void) printf(RECEIVED_PROMPT);
		(void) fflush(stdout);
		(void) write(STDOUT_FILENO, buff, len);
		
		
	}
	break;
	}

	/* iteration ends when EOF found on stdin or chat connection */

	(void) send_eof(conn);
	(void) printf("\nChat Connection Closed.\n\n");
	return 0;
}