//Show some pipe usage

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <cnaiapi.h>

#define BUFFSIZE		256
#define INPUT_PROMPT		"\nInput   > "
#define RECEIVED_PROMPT		"\nReceived> "
#define NUM_THREADS     2


int recvln(connection, char *, int);
int readln(char *, int);

char		buff[BUFFSIZE];
connection	conn;
int		len,rc,t,nthreads, tid;
long n=2;

int main(int argc, char *argv[])
{
	
	

	if (argc != 2) {
		(void) fprintf(stderr, "usage: %s <a_port_num> <function select 1=send 2=receive>\n", argv[0]);
		exit(1);
	}

	(void) printf("Chat Server Waiting For Connection.\n");

	/* wait for a connection from a chatclient */

	conn = await_contact((appnum) atoi(argv[1]));

	if (conn < 0){
		exit(1);
	}
	
	(void) printf("Chat Connection Established.\n");
	(void) fflush(stdout);
	(void) printf(INPUT_PROMPT);
		(void) fflush(stdout);
 
 omp_set_num_threads(n);
 
 #pragma omp parallel sections 
 { 
 #pragma omp section 
 { 
 while((len = readln(buff, BUFFSIZE)) > 0) {
		buff[len - 1] = '\n';
		(void) send(conn, buff, len, 0);
		
		(void) printf(INPUT_PROMPT);
		(void) fflush(stdout);
	}
 }
 
 
 #pragma omp section 
 { 
  while((len = recvln(conn, buff, BUFFSIZE)) > 0) {
		(void) printf(RECEIVED_PROMPT);
		(void) fflush(stdout);
		(void) write(STDOUT_FILENO, buff, len);
		(void) fflush(stdout);
		(void) printf(INPUT_PROMPT);
		(void) fflush(stdout);
		
	}
 }
 
}
 
 /* iteration ends when EOF found on stdin or chat connection */

	(void) send_eof(conn);
	(void) printf("\nChat Connection Closed.\n\n");
	pthread_exit(NULL);
	return 0;
}
