//Libraries for Handling Audio Input Devices 
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
//General Purpose Libraries
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
//Library for Handling Sound Files
#include <sndfile.h>
using namespace std;

#define	BUFFER_LEN	1024
#define MAX_CHANNELS	6

#define	PI	3.14159265358979323846264338
#define M_LN2 0.69314718055994530942
#define FILTER_SECTIONS   2  /* 2 filter sections for 24 db/oct filter */

/* whatever sample type you want */
typedef double smp_type;
/* this holds the data required to update samples thru a filter */
typedef struct {
smp_type a0, a1, a2, a3, a4;
smp_type x1, x2, y1, y2;
}
biquad;

void mainmenu();
int playback(int opt);
int record_sound(float length);
int plot_sound(int opt);
int convert_to_text(int opt);
static int tone_create (double sr, double interval_sec, double amplitude, double frequency, int channels);
static int amplify_data (double gain);
static int reverce_data ();
extern smp_type BiQuad(smp_type sample, biquad * b);

extern biquad *BiQuad_new(int type, smp_type dbGain, /* gain of filter */
smp_type freq, /* center frequency */
smp_type srate, /* sampling rate */
smp_type q); /* quality factor */

int bandpass_filter();
int stopband_filter();
static int filter();


/* filter types */
enum {
LPF, /* low pass filter */
HPF, /* High pass filter */
BPF, /* band pass filter */
NOTCH, /* Notch Filter */
PEQ, /* Peaking band EQ filter */
LSH, /* Low shelf filter */
HSH /* High shelf filter */
};



static double data [BUFFER_LEN];
SNDFILE *infile, *outfile;
SF_INFO sfinfo ;
SF_FORMAT_INFO info;

biquad *flt;
biquad *secondary_flt;

double   fs, fc;     /* Sampling frequency, cutoff frequency OR Sampling frequency, frequency of Tone*/
double   fl,fu;		/* Used for BandPass and StopBand filters */
double   k;           /* overall gain factor OR amplitude of Tone OR The amplification factor*/
double   Q;     /* Resonance > 1.0 < 1000 OR interval of Tone*/
double   timeplot; /*The time for ploting the samples*/
double   work;		/*GENERAL PURPOSE VARIABLE */

int	readcount, err,opt1,opt2,chan,stopmenu,stopplay;

char infilename[300];
char outfilename[300];

int main (){
	
err=1;

mainmenu();
	
return err;
}

void mainmenu(){
	
	stopmenu=0;
    opt1=0;
	opt2=0;
	
		printf("Enter the name and the path of the sound file to be processed, input file *.wav .\n:>>");
		scanf("%s",infilename);
		printf("Enter the name and the path of the output file *.wav .\n:>>");
		scanf("%s",outfilename);
	while(!stopmenu){
		printf("\n");
		printf("Select 1 to reverce waveform.\nSelect 2 to amplify waveform.\nSelect 3 to produce a Tone Waveform.\nSelect 4 to process waveform through an IIR Filter.\nSelect 5 to PlayBack either the Input or the Output Sound File.\nSelect 6 to plot the waveform (You Must have installed GNUPLOT package for this opperation).\nSelect 7 to Record from Microphone to the Output Sound File.\nSelect anything else to quit.\n\n:>>");
		scanf("%d",&opt1);
		
		
	
		switch (opt1){
		case 1:
		err=reverce_data ();
		break;
		case 2:
		printf("\nEnter the amplification factor.\n:>>");
		scanf("%lf",&k);
		err=amplify_data(k);
		break;
		case 3:
		fs=44100;
		printf("\nThe value of sample rate is %lf Hz by default.\n",fs);
		printf("Enter the frequency of the Tone in Hz.\n:>>");
		scanf("%lf",&fc);
		printf("\nEnter the Tones duration in seconds.\n:>>");
		scanf("%lf",&Q);
		printf("\nEnter the Tones Amplitude Vp. Maximum value is 2.\n:>>");
		scanf("%lf",&k);
		chan=1;
		printf("\nThe number of channels is %d by default.\n",chan);
		err=tone_create (fs, Q, k, fc, chan);
		break;
		case 4:
		fs=44100;
		k=0; //Overall Gain in DB
		Q=0.707;
		printf("\nSelect the filter type:\n1. For Low Pass Filter.\n2. For High Pass Filter.\n3. For Bandpass Filter.\n4. For Stopband Filter.\n5. For Notch Filter.\n6. For Low Shelf Filter.\n7. For High Shelf Filter\n:>>");
		scanf("%d",&opt2);	
			while(stopmenu==0){
				switch(opt2){
					case 1:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of samplerate is set to %lf KHz.\n",fs);
					printf("Enter the cutoff frequency in Hz.\n:>>");
					scanf("%lf",&fc);
					flt=BiQuad_new(LPF, k, fc,fs, Q);
					err=filter();
					stopmenu=1;
					break;
					case 2:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of sample rate is set to %lf KHz.\n",fs);
					printf("Enter the cutoff frequency in Hz.\n:>>");
					scanf("%lf",&fc);
					flt=BiQuad_new(HPF, k, fc,fs, Q);
					err=filter();
					stopmenu=1;
					break;
					case 3:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of sample rate is set to %lf KHz.\n",fs);
					printf("Enter the Lower Cutoff frequency in Hz.\n:>>");
					scanf("%lf",&fu);
					printf("\nEnter the Higher Cutoff frequency in Hz.\n:>>");
					scanf("%lf",&fl);
					err=bandpass_filter();
					stopmenu=1;
					break;
					case 4:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of sample rate is set to %lf KHz.\n",fs);
					printf("Enter the Lower Cutoff frequency in Hz.\n:>>");
					scanf("%lf",&fl);
					printf("\nEnter the Higher Cutoff frequency in Hz.\n:>>");
					scanf("%lf",&fu);
					err=stopband_filter();
					stopmenu=1;
					break;
					case 5:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of samplerate is set to %lf KHz.\n",fs);
					printf("Enter the Central (Fc) frequency to cuttoff in Hz.\n:>>");
					scanf("%lf",&fc);
					flt=BiQuad_new(NOTCH, k, fc,fs, Q);
					err=filter();
					stopmenu=1;
					break;
					case 6:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of samplerate is set to %lf KHz.\n",fs);
					printf("Enter the Fc frequency in Hz.\n:>>");
					scanf("%lf",&fc);
					flt=BiQuad_new(LSH, k, fc,fs, Q);
					err=filter();
					stopmenu=1;
					break;
					case 7:
					printf("\nEnter the SAMPLERATE of the sound you want to Filter in KHz.\n:>>");
					scanf("%lf",&fs); 
					printf("\nThe value of samplerate is set to %lf KHz.\n",fs);
					printf("Enter the Fc frequency in Hz.\n:>>");
					scanf("%lf",&fc);
					flt=BiQuad_new(HSH, k, fc,fs, Q);
					err=filter();
					stopmenu=1;
					break;
				}
		}
		stopmenu=0;
		opt2=0;
		break;
		case 5:
		printf("\nSelect the sound file to play:\n1. For Input Sound File.\n2. For Output Sound File.\n:>>");
		scanf("%d",&opt2);
		stopplay=0; //0 Do not stop play sound file. 1 Stop play sound file.
		err=playback(opt2);
		opt2=0;
		break;
		case 6:
		printf("\nSelect the sound file to plot waveform:\n1. For Input Sound File.\n2. For Output Sound File.\n:>>");
		scanf("%d",&opt2);
		err=plot_sound(opt2);
		opt2=0;
		break;
		case 7:
		printf("\nSelect the Duration in seconds of the recording.\n:>>");
		scanf("%lf",&work);
		stopplay=0; //0 Do not stop play sound file. 1 Stop play sound file.
		err=record_sound(work);
		work=0.0;
		opt2=0;
		break;
		default :
		stopmenu=1;
		printf("\n.........\nThis Program created by Panagiotis Georgiopoulos it07185\n\n");
		err=0;
	    }
	}
	
}

static int tone_create (double sr, double interval_sec, double amplitude, double frequency, int channels){
	//Produse a Tone
	
	sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
    SNDFILE	*file;
	
	int	k;
	int	*buffer=NULL;
	
	if (amplitude>1.5){
		printf("Maximun allowed value for amplitude is 1.5 . Setting amplitude to 1.5\n");
		amplitude=1.5;
	}
	
	amplitude *= 0x7F000000;
	amplitude /=2;
	frequency /= sr;
	
	k=sr*interval_sec*channels;
	if (! (buffer = new int[k])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	k=0;
	
	memset (&sfinfo, 0, sizeof (sfinfo));

	sfinfo.samplerate	= sr;
	sfinfo.frames		= sr*interval_sec;
	sfinfo.channels		= channels;
	sfinfo.format		= (SF_FORMAT_WAV | SF_FORMAT_PCM_24);


	if (sfinfo.channels == 1){
		
		for (k = 0 ; k < sfinfo.frames ; k++){
			buffer [k] = amplitude * sin (frequency * 2 * k * PI);
		}
		
					
	}else if (sfinfo.channels == 2){
		
		for (k = 0 ; k < sfinfo.frames ; k++){
			buffer [2 * k] = amplitude * sin (frequency * 2 * k * PI) ;
			buffer [2 * k + 1] = amplitude * sin (frequency * 2 * k * PI) ;
		}
		
	}else{
		
		printf ("makesine can only generate mono or stereo files.\n");
		exit (1);
		
	}

	if (! (file = sf_open (outfilename , SFM_WRITE, &sfinfo))){
		printf ("Error : Not able to open output file.\n");
		return 1;
	}
	
	
	if (sf_write_int (file, buffer, channels*sr*interval_sec) == channels*sr*interval_sec){
		//puts (sf_strerror (file));
	}else{
		printf("File was not writen\n");
	}
	
	delete [] buffer;
		buffer = NULL;	
	sf_close (file);
	
	//END Produce Tone
	return 0 ;
}

static int amplify_data (double gain){
	//Amplify waveform without clipping
	
	
	double channel_gain [MAX_CHANNELS] = { gain, gain, gain, gain, gain, gain } ;
    int k, chan ;
	
	if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        printf ("Not able to open input file %s.\n", infilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }

    if (sfinfo.channels > MAX_CHANNELS){
		printf ("Not able to process more than %d channels\n", MAX_CHANNELS) ;
        return 1 ;
        }	
		
	if (! (outfile = sf_open (outfilename, SFM_WRITE, &sfinfo))){
		printf ("Not able to open output file %s.\n", outfilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
    sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
    while ((readcount = sf_read_double (infile, data, BUFFER_LEN))){
    for (chan = 0 ; chan < sfinfo.channels ; chan ++){
        for (k = chan ; k < readcount ; k+= sfinfo.channels){
            data [k] *= channel_gain [chan] ;
		}
	}
	sf_write_double (outfile, data, readcount);
	}
	
	sf_close (infile);
	sf_close (outfile);
	
	//END Amplify
	
    return 0;
} 

static int reverce_data (){
	
	//Reverce waveform
	sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_FALSE);		
	long all_count_data,i,k;
	
	
	
	if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        printf ("Not able to open input file %s.\n", infilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }

    if (sfinfo.channels > MAX_CHANNELS){
		printf ("Not able to process more than %d channels\n", MAX_CHANNELS) ;
        return 1 ;
        }
		
		     	
		all_count_data=sfinfo.frames*sfinfo.channels;
			
		double *tempdata = NULL;
		tempdata = new double[all_count_data];
					
		i=0;
		while ((readcount = sf_read_double (infile, data, BUFFER_LEN))){
						
				for (k = 0 ; k <readcount ; k++){
            	tempdata[all_count_data-i-1]=data[k];
				i++;
					
				}
		}
						
		if (! (outfile = sf_open (outfilename, SFM_WRITE, &sfinfo))){
		printf ("Not able to open output file %s.\n", outfilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
		sf_write_double (outfile, tempdata, all_count_data) ;
			
		
		delete [] tempdata;
		tempdata = NULL;
		//end reverce waveform
    
	sf_close (infile);
	sf_close (outfile);
	
    return 0;
} 


int bandpass_filter(){
	sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
    
	
	int	k,channels,m;
	float sr;
	float *bufferin=NULL;
	float *bufferout=NULL;
		
	if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        printf ("Not able to open input file %s.\n", infilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
	channels=sfinfo.channels;
	sr=sfinfo.samplerate;	
		
	if (! (outfile = sf_open (outfilename, SFM_WRITE, &sfinfo))){
		printf ("Not able to open output file %s.\n", outfilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
		
	if (! (bufferin = new float[BUFFER_LEN*channels])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	
	if (! (bufferout = new float[BUFFER_LEN*channels])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	
	flt=BiQuad_new(HPF, k, fu,fs, Q);	
	secondary_flt=BiQuad_new(LPF, k, fl,fs, Q);
	while ((readcount = sf_readf_float (infile, bufferin, BUFFER_LEN)) > 0){
		for (k = 0 ; k < readcount ; k++){
			for (m = 0 ; m < channels ; m++){
				bufferout[k * channels + m]=BiQuad(bufferin[k * channels + m], flt);
				bufferout[k * channels + m]=BiQuad(bufferout[k * channels + m], secondary_flt);				
			}
		}
		sf_writef_float(outfile,bufferout,BUFFER_LEN);
	}
	
	delete [] bufferin;
	delete [] bufferout;
	bufferin=NULL;
	bufferout=NULL;
	
	sf_close (infile);
	sf_close (outfile);
		
	return 0;
}

int stopband_filter(){
	sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
    
	
	int	k,channels,m;
	float sr;
	float *bufferin=NULL;
	float *bufferout=NULL;
		
	if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        printf ("Not able to open input file %s.\n", infilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
	channels=sfinfo.channels;
	sr=sfinfo.samplerate;	
		
	if (! (outfile = sf_open (outfilename, SFM_WRITE, &sfinfo))){
		printf ("Not able to open output file %s.\n", outfilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
		
	if (! (bufferin = new float[BUFFER_LEN*channels])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	
	if (! (bufferout = new float[BUFFER_LEN*channels])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	
	flt=BiQuad_new(LPF, k, fl,fs, Q);	
	secondary_flt=BiQuad_new(HPF, k, fu,fs, Q);
	while ((readcount = sf_readf_float (infile, bufferin, BUFFER_LEN)) > 0){
		for (k = 0 ; k < readcount ; k++){
			for (m = 0 ; m < channels ; m++){
				bufferout[k * channels + m]=BiQuad(bufferin[k * channels + m], flt);
				bufferout[k * channels + m]-=BiQuad(bufferin[k * channels + m], secondary_flt);				
			}
		}
		sf_writef_float(outfile,bufferout,BUFFER_LEN);
	}
	
	delete [] bufferin;
	delete [] bufferout;
	bufferin=NULL;
	bufferout=NULL;
	
	sf_close (infile);
	sf_close (outfile);
		
	return 0;
}

static int filter(){
	sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
    
	
	int	k,channels,m;
	float sr;
	float *bufferin=NULL;
	float *bufferout=NULL;
		
	if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        printf ("Not able to open input file %s.\n", infilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
	channels=sfinfo.channels;
	sr=sfinfo.samplerate;	
		
	if (! (outfile = sf_open (outfilename, SFM_WRITE, &sfinfo))){
		printf ("Not able to open output file %s.\n", outfilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
        }
		
	if (! (bufferin = new float[BUFFER_LEN*channels])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	
	if (! (bufferout = new float[BUFFER_LEN*channels])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}
	
		
	while ((readcount = sf_readf_float (infile, bufferin, BUFFER_LEN)) > 0){
		for (k = 0 ; k < readcount ; k++){
			for (m = 0 ; m < channels ; m++){
				bufferout[k * channels + m]=BiQuad(bufferin[k * channels + m], flt);
			}
		}
		sf_writef_float(outfile,bufferout,BUFFER_LEN);
	}
	
	delete [] bufferin;
	delete [] bufferout;
	bufferin=NULL;
	bufferout=NULL;
	
	sf_close (infile);
	sf_close (outfile);
	return 0;
}

/* Below this would be biquad.c */
/* Computes a BiQuad filter on a sample */
smp_type BiQuad(smp_type sample, biquad * b)
{
smp_type result;
/* compute result */
result = b->a0 * sample + b->a1 * b->x1 + b->a2 * b->x2 -
b->a3 * b->y1 - b->a4 * b->y2;
/* shift x1 to x2, sample to x1 */
b->x2 = b->x1;
b->x1 = sample;
/* shift y1 to y2, result to y1 */
b->y2 = b->y1;
b->y1 = result;
return result;
}


/* sets up a BiQuad Filter */
biquad *BiQuad_new(int type, smp_type dbGain, smp_type freq,smp_type srate, smp_type q)
{
biquad *b= NULL;
b= new biquad[sizeof(biquad)];
smp_type A, omega, sn, cs, alpha, beta;
smp_type a0, a1, a2, b0, b1, b2;
//b = malloc(sizeof(biquad));
if (b == NULL){
return NULL;
printf("\n b was null");
}
/* setup variables */
A = pow(10, dbGain /40);
omega = 2 * M_PI * freq /srate;
sn = sin(omega);
cs = cos(omega);
alpha = sn/(2*Q);
beta = sqrt(A + A);
switch (type) {
case LPF:
b0 = (1 - cs) /2;
b1 = 1 - cs;
b2 = (1 - cs) /2;
a0 = 1 + alpha;
a1 = -2 * cs;
a2 = 1 - alpha;
break;
case HPF:
b0 = (1 + cs) /2;
b1 = -(1 + cs);
b2 = (1 + cs) /2;
a0 = 1 + alpha;
a1 = -2 * cs;
a2 = 1 - alpha;
break;
case BPF:
b0 = alpha;
b1 = 0;
b2 = -alpha;
a0 = 1 + alpha;
a1 = -2 * cs;
a2 = 1 - alpha;
break;
case NOTCH:
b0 = 1;
b1 = -2 * cs;
b2 = 1;
a0 = 1 + alpha;
a1 = -2 * cs;
a2 = 1 - alpha;
break;
case PEQ:
b0 = 1 + (alpha * A);
b1 = -2 * cs;
b2 = 1 - (alpha * A);
a0 = 1 + (alpha /A);
a1 = -2 * cs;
a2 = 1 - (alpha /A);
break;
case LSH:
b0 = A * ((A + 1) - (A - 1) * cs + beta * sn);
b1 = 2 * A * ((A - 1) - (A + 1) * cs);
b2 = A * ((A + 1) - (A - 1) * cs - beta * sn);
a0 = (A + 1) + (A - 1) * cs + beta * sn;
a1 = -2 * ((A - 1) + (A + 1) * cs);
a2 = (A + 1) + (A - 1) * cs - beta * sn;
break;
case HSH:
b0 = A * ((A + 1) + (A - 1) * cs + beta * sn);
b1 = -2 * A * ((A - 1) + (A + 1) * cs);
b2 = A * ((A + 1) + (A - 1) * cs - beta * sn);
a0 = (A + 1) - (A - 1) * cs + beta * sn;
a1 = 2 * ((A - 1) - (A + 1) * cs);
a2 = (A + 1) - (A - 1) * cs - beta * sn;
break;
default:
delete [] b;
b=NULL;
return NULL;
}
/* precompute the coefficients */
printf("\n\nThe filter coefficients are:\n");
b->a0 = b0 /a0;
printf("%lf\n",b->a0);
b->a1 = b1 /a0;
printf("%lf\n",b->a1);
b->a2 = b2 /a0;
printf("%lf\n",b->a2);
b->a3 = a1 /a0;
printf("%lf\n",b->a3);
b->a4 = a2 /a0;
printf("%lf\n",b->a4);
/* zero initial samples */
b->x1 = b->x2 = 0;
b->y1 = b->y2 = 0;
return b;
}


int playback(int opt){
	 
	 int fd,status,k,arg;	/* sound device file descriptor */
	 short *buffer=NULL;
	 	 
	fd = open("/dev/dsp", O_RDWR);
 	if (fd < 0) {
   		perror("open of /dev/dsp failed");
    	exit(1);
  	}
	
	if (opt==1){
		if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        	printf ("Not able to open input file %s.\n", infilename) ;
        	puts (sf_strerror (NULL)) ;
        	return 1;
        }
	}else if (opt==2){
		if (! (infile = sf_open (outfilename, SFM_READ, &sfinfo))) {  
        	printf ("Not able to open input file %s.\n", infilename) ;
        	puts (sf_strerror (NULL)) ;
        	return 1;
        }	
	}else{
		printf("\nInvalid option for PlayBack Function. Must be 1 OR 2.\n");
		return 1;
	}

    if (sfinfo.channels > MAX_CHANNELS){
		printf ("Not able to process more than %d channels\n", MAX_CHANNELS) ;
        return 1 ;
        }
	
	 /* set sampling parameters */
  arg = 16;	   /* sample size */
  status = ioctl(fd, SOUND_PCM_WRITE_BITS, &arg);
  if (status == -1){
    perror("SOUND_PCM_WRITE_BITS ioctl failed");
	}
 

  
   arg = sfinfo.channels;  /* mono or stereo */
  status = ioctl(fd, SOUND_PCM_WRITE_CHANNELS, &arg);
  if (status == -1){
    perror("SOUND_PCM_WRITE_CHANNELS ioctl failed");
  }
  
  arg = sfinfo.samplerate;	   /* sampling rate */
  status = ioctl(fd, SOUND_PCM_WRITE_RATE, &arg);
  if (status == -1){
    perror("SOUND_PCM_WRITE_WRITE ioctl failed");
  }
			
	if (! (buffer = new short[sfinfo.samplerate])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}	
		
	status = ioctl(fd, SOUND_PCM_SYNC, 0);
    sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
    while(readcount = sf_read_short (infile, buffer, sfinfo.samplerate)){
    	if (stopplay==0){
			status = write(fd, buffer, sfinfo.samplerate*sizeof(short)); /* play it back */
		}else if (stopplay==1){
			break;
		}else{
			printf("\nInvaliv value of variable stopplay. Must be 0 OR 1. Stopping\n");
			break;
		}
		for (k=0;k<sfinfo.samplerate;k++){
			buffer[k]=0;
		}		
		
	}
	status = ioctl(fd, SOUND_PCM_SYNC, 0);
	
	sf_close (infile);
	close(fd);
	delete [] buffer;
	buffer = NULL;
	
		
    return 0;		
}



int record_sound(float length){
	
	int fd,status,arg;	/* sound device file descriptor */
	long k;
	short *buffer=NULL;
	fd = open("/dev/dsp", O_RDWR);
 	if (fd < 0) {
   		perror("open of /dev/dsp failed");
    	exit(1);
  	}
		 /* set sampling parameters */
  arg = 16;	   /* sample size */
  status = ioctl(fd, SOUND_PCM_WRITE_BITS, &arg);
  if (status == -1){
    perror("SOUND_PCM_WRITE_BITS ioctl failed");
	}
 

  
   arg = 1;  /* mono or stereo */
  status = ioctl(fd, SOUND_PCM_WRITE_CHANNELS, &arg);
  if (status == -1){
    perror("SOUND_PCM_WRITE_CHANNELS ioctl failed");
  }
  
  arg = 44100;	   /* sampling rate */
  status = ioctl(fd, SOUND_PCM_WRITE_RATE, &arg);
  if (status == -1){
    perror("SOUND_PCM_WRITE_WRITE ioctl failed");
  }
	
	k=length*44100*16*1/8;		
	if (! (buffer = new short[k])){
		printf ("allocation failed.\n") ;
		exit (0) ;
	}	
		
	status = ioctl(fd, SOUND_PCM_SYNC, 0);
    sf_command (outfile, SFC_SET_CLIPPING, NULL, SF_TRUE);
	
	printf("\nRecording........\n");
	status = read(fd, buffer, k); /* record some sound */
    if (status != k){
    	perror("read wrong number of bytes");
    }
	printf("\nSaving to output file........\n");
	
	memset (&sfinfo, 0, sizeof (sfinfo));

	sfinfo.samplerate	= 44100;
	sfinfo.frames		= k;
	sfinfo.channels		= 1;
	sfinfo.format		= (SF_FORMAT_WAV | SF_FORMAT_PCM_24);

	
	if (! (outfile = sf_open (outfilename, SFM_WRITE, &sfinfo))){
		printf ("Not able to open output file %s.\n", outfilename) ;
        puts (sf_strerror (NULL)) ;
        return 1 ;
    }

	sf_writef_short(outfile,buffer,k/2);
	status = ioctl(fd, SOUND_PCM_SYNC, 0);
	
	status = ioctl(fd, SOUND_PCM_SYNC, 0);
	delete [] buffer;
	buffer = NULL;
	close(fd);
	sf_close (outfile);
	
	return 0;
}



int convert_to_text(int opt){
	float *buffer=NULL;
	int k, m, readcount;
	FILE *ofile=NULL;
		
	if (opt==1){
		if (! (infile = sf_open (infilename, SFM_READ, &sfinfo))) {  
        	printf ("Not able to open input file %s.\n", infilename) ;
        	puts (sf_strerror (NULL)) ;
        	return 1;
        }
	}else if (opt==2){
		if (! (infile = sf_open (outfilename, SFM_READ, &sfinfo))) {  
        	printf ("Not able to open input file %s.\n", infilename) ;
        	puts (sf_strerror (NULL)) ;
        	return 1;
        }	
	}else{
		printf("\nInvalid option for PlayBack Function. Must be 1 OR 2.\n");
		return 1;
	}
	
	/* Open the output file txt. */
	if (opt==1){
		if ((ofile = fopen ("gp_datain.gp", "w")) == NULL){
			printf ("Not able to open output file %s : %s\n", "gp_datain.gp", sf_strerror (NULL)) ;
			return 1 ;
		} 
	}else if (opt==2){
		if ((ofile = fopen ("gp_dataout.gp", "w")) == NULL){
			printf ("Not able to open output file %s : %s\n", "gp_dataout.gp", sf_strerror (NULL)) ;
			return 1 ;
		} 
	}else{
		printf("The opt parameter in convert_to_text was not valid");
		err=1;
	}
	if (! (buffer = new float[sfinfo.channels*BUFFER_LEN])){
		printf ("allocation failed.\n") ;
		exit (0);
	}	

	timeplot=0;
	while ((readcount = sf_readf_float (infile, buffer, BUFFER_LEN)) > 0){
		for (k = 0 ; k < readcount ; k++){
			fprintf (ofile, " %12.6lf", timeplot);
				for (m = 0 ; m < sfinfo.channels ; m++){
					fprintf (ofile, " %3.6f", buffer [k * sfinfo.channels + m]);
				}	
			timeplot+=(double)(1.0/sfinfo.samplerate);	
			fprintf (ofile, "\n") ;
		} 
	} 
	
	sf_close (infile) ;
	fclose (ofile) ;
	
	delete [] buffer;
	buffer = NULL;
	
	return 0;
}

int plot_sound(int opt){
	err=convert_to_text(opt);
	if (opt==1){
		system("gnuplot -persist ploterin.gp");
	}else if (opt==2){
		system("gnuplot -persist ploterout.gp");
	}else{
		printf("The opt parameter in plot_sound was not valid");
		err=1;
	}
	return err;
}
